// ChooseSpecificDate.cpp : implementation file
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
#include "stdafx.h"
#include "DaysEase.h"
#include "ChooseSpecificDate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CDaysEaseApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CChooseSpecificDate dialog


CChooseSpecificDate::CChooseSpecificDate(CWnd* pParent /*=NULL*/)
	: CDialog(CChooseSpecificDate::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChooseSpecificDate)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CChooseSpecificDate::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChooseSpecificDate)
	DDX_Control(pDX, IDC_TODAY, m_Today);
	DDX_Control(pDX, IDC_LISTYEAR, m_ListYear);
	DDX_Control(pDX, IDC_LISTMONTH, m_ListMonth);
	DDX_Control(pDX, IDC_LISTDAY, m_ListDay);
	DDX_Control(pDX, IDC_ANNUAL, m_Annual);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChooseSpecificDate, CDialog)
	//{{AFX_MSG_MAP(CChooseSpecificDate)
	ON_BN_CLICKED(IDC_ANNUAL, OnAnnual)
	ON_LBN_SELCHANGE(IDC_LISTDAY, OnSelchangeListday)
	ON_LBN_SELCHANGE(IDC_LISTMONTH, OnSelchangeListmonth)
	ON_LBN_SELCHANGE(IDC_LISTYEAR, OnSelchangeListyear)
	ON_BN_CLICKED(IDC_TODAY, OnToday)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChooseSpecificDate message handlers

void CChooseSpecificDate::Adjust_ListDay()
{
	int count;
	char string[3];

	// The following adjusts the number of days in each month when the month changes.
	switch(m_ListMonth.GetCurSel())
	{
	case 1:
		Set_February();
		break;
	case 3:
	case 5:
	case 8:
	case 10:
		while((count = m_ListDay.GetCount()) < 30)
		{
			itoa(count + 1, string, 10);
			m_ListDay.AddString(string);
		}
		if(count == 31)
			m_ListDay.DeleteString(30);
		if(m_SaveState[2] == " 31")
		{
			theApp.EventDate[2] = m_SaveState[2] = " 30";
			m_ListDay.SetCurSel(29);
		}
		break;
	default :
		while((count = m_ListDay.GetCount()) < 31)
		{
			itoa(count + 1, string, 10);
			m_ListDay.AddString(string);
		}
	}
}

void CChooseSpecificDate::OnAnnual() 
{
	if(m_Annual.GetCheck())
	{
		theApp.EventDate[3].Empty();
		// Assemble EventDate.
		theApp.EventDate[0] = m_SaveState[0] = m_SaveState[1].Left(3) + m_SaveState[2];
		// Could be a leap year, so call Adjust_ListDay() to add 29th to February.
		Adjust_ListDay();
		// Deselect year.
		m_ListYear.SetCurSel(-1);
		// Disable the year list.
		m_ListYear.EnableWindow(FALSE);
	}
	else
	{
		// Enable the year list.
		m_ListYear.EnableWindow(TRUE);
		// Select the year that we had previously.
		m_ListYear.SelectString(-1, m_SaveState[3].Right(4));
		// Add the year back to the EventDate variable.
		theApp.EventDate[3] = m_SaveState[3];
		// Could be a leap year, so call Adjust_ListDay() to adjust February.
		Adjust_ListDay();
		// Do the standard EventDate assembly .
		Set_List_Entry();
	}
	// Let the ChooseDate dialog know that the date changed.
	GetParentOwner()->PostMessage(WM_MY_DATE_CHANGED, NULL, NULL);
}

BOOL CChooseSpecificDate::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CString csMonth[12] = {"January", "February", "March", "April", "May",
		"June", "July", "August", "September", "October", "November", "December"};
	int i;
	char ch[5];

	// Get todays date - must prefix with CTime::
	CTime ctCurrent_Date = CTime::GetCurrentTime();
	// Get the year integer
	int nYear = ctCurrent_Date.GetYear();
	// Get the month integer
	int nMonth = ctCurrent_Date.GetMonth();
	// Get the day integer
	int nDay = ctCurrent_Date.GetDay();

	// Fill the Year list with all valid years.
	for(i = 1970; i < 2038; i++)
	{
		itoa(i, ch, 10);
		m_ListYear.AddString(ch);
	}
	// Convert the current year integer to a string.
	itoa(nYear, ch, 10);
	// Select the current year as default.
	m_ListYear.SelectString(0, ch);
	// Position the current year so it shows in the list.
	m_ListYear.SetTopIndex(m_ListYear.GetCurSel() - 2);
	// Initialize m_SaveState with formatted current year.
	m_SaveState[3] = CString(", ") + ch;
	// Fill in the Month list.
	for(i = 0; i < 12; i++)
	{
		m_ListMonth.AddString(csMonth[i]);
	}
	// Select the current month, adjusting for zero base.
	m_ListMonth.SetCurSel(nMonth -1);
	// Position the current month so it shows in the list.
	m_ListMonth.SetTopIndex(m_ListMonth.GetCurSel() - 2);
	// Grap the current month string from the list and save it.
	m_ListMonth.GetText(nMonth -1, m_SaveState[1]);
	// Fill in the Day list.
	for(i = 1; i < 10; i++)
	{
		// Add a preceding 0 so that all days have two characters.
		itoa(i, ch, 10);
		m_ListDay.AddString("0" + CString(ch));
	}
	// Continue filling.
	for(i = 10; i < 31; i++)
	{
		itoa(i, ch, 10);
		m_ListDay.AddString(ch);
	}
	// Select the current day, adjusting for zero base.
	m_ListDay.SetCurSel(nDay -1);
	// Call Adjust_ListDay() to correct the proper number for this month.
	Adjust_ListDay();
	// Position the current day so it shows in the list.
	m_ListDay.SetTopIndex(m_ListDay.GetCurSel() - 2);
	// Grap the current day string from the list and save it.
	m_ListDay.GetText(nDay -1, m_SaveState[2]);
	// Add a preceding space.
	m_SaveState[2] = " " + m_SaveState[2];
	// Set the EventDate variables.
	for(i = 1; i < 4; i++)
		theApp.EventDate[i] = m_SaveState[i];
	// Do the standard EventDate assembly.
	Set_List_Entry();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
// Handler for Day List change.
void CChooseSpecificDate::OnSelchangeListday() 
{
	// Grab the current selection from the list and save it.
	m_ListDay.GetText(m_ListDay.GetCurSel(), m_SaveState[2]);
	// Add a preceding space.
	m_SaveState[2] = " " + m_SaveState[2];
	// Set the EventDate variable.
	theApp.EventDate[2] = m_SaveState[2];
	// Do the standard EventDate assembly.
	Set_List_Entry();
	// Let the ChooseDate dialog know that the date changed.
	GetParentOwner()->PostMessage(WM_MY_DATE_CHANGED, NULL, NULL);
}
// Handler for Month List change.
void CChooseSpecificDate::OnSelchangeListmonth() 
{
	// Grab the current selection from the list and save it.
	m_ListMonth.GetText(m_ListMonth.GetCurSel(), m_SaveState[1]);
	// Set the EventDate variable.
	theApp.EventDate[1] = m_SaveState[1];
	// Call Adjust_ListDay() to correct the proper number for this month.
	Adjust_ListDay();
	// Do the standard EventDate assembly.
	Set_List_Entry();
	// Let the ChooseDate dialog know that the date changed.
	GetParentOwner()->PostMessage(WM_MY_DATE_CHANGED, NULL, NULL);
}
// Handler for Year List change.
void CChooseSpecificDate::OnSelchangeListyear() 
{
	// Grab the current selection from the list and save it.
	m_ListYear.GetText(m_ListYear.GetCurSel(), m_SaveState[3]);
	// Add a preceding comma and space.
	m_SaveState[3] = ", " + m_SaveState[3];
	// Call Adjust_ListDay() to correct the proper number for this month.
	Adjust_ListDay();
	// Set the EventDate variable.
	theApp.EventDate[3] = m_SaveState[3];
	// Do the standard EventDate assembly.
	Set_List_Entry();
	// Let the ChooseDate dialog know that the date changed.
	GetParentOwner()->PostMessage(WM_MY_DATE_CHANGED, NULL, NULL);
}

void CChooseSpecificDate::OnToday() 
{
	char ch[20];
	// Get todays date - must prefix with CTime::
	CTime ctCurrent_Date = CTime::GetCurrentTime();
	// Get the year integer
	int nYear = ctCurrent_Date.GetYear();
	// Get the month integer
	int nMonth = ctCurrent_Date.GetMonth();
	// Get the day integer
	int nDay = ctCurrent_Date.GetDay();

	
	m_ListMonth.SetCurSel(nMonth -1);
	m_ListMonth.SetTopIndex(m_ListMonth.GetCurSel() - 2);
	m_ListMonth.GetText(nMonth -1, m_SaveState[1]);
	
	m_ListDay.SetCurSel(nDay -1);
	m_ListDay.SetTopIndex(m_ListDay.GetCurSel() - 2);
	m_ListDay.GetText(nDay -1, m_SaveState[2]);
	m_SaveState[2] = " " + m_SaveState[2];
	
	itoa(nYear, ch, 10);
	m_ListYear.SelectString(0, ch);
	m_ListYear.SetTopIndex(m_ListYear.GetCurSel() - 2);
	m_SaveState[3] = CString(", ") + ch;
	for(int i = 0; i < 4; i++)
		theApp.EventDate[i] = m_SaveState[i];
	if(m_Annual.GetCheck())
	{
		theApp.EventDate[3].Empty();
		m_ListYear.SetCurSel(-1);
	}
	// Let the ChooseDate dialog know that the date changed.
	GetParentOwner()->PostMessage(WM_MY_DATE_CHANGED, NULL, NULL);
}

void CChooseSpecificDate::Set_February()
{
	int count, cursel, nDays(29);
	char string[3];

	cursel = m_ListDay.GetCurSel();
	while((count = m_ListDay.GetCount()) > 28)
		m_ListDay.DeleteString(count - 1);
	if(m_Annual.GetCheck())
		m_ListDay.AddString("29");
	else
	{
		CTimeSpan cts;
		CTime ctFirst_Day, ctLast_Day;
		CString Year;

		m_ListYear.GetText(m_ListYear.GetCurSel(), Year);
		// Get a CTime object for the first day of this month
		ctFirst_Day = CTime(atoi(Year), 2, 1, 0, 0, 0, 0);
		// Otherwise increment month only
		ctLast_Day = CTime(atoi(Year), 3, 1, 0, 0, 0, 0);
		// Get a CTimeSpan value for the month
		// this method frees us from calculating leap years
		// because CTimeSpan does it automatically
		cts = ctLast_Day - ctFirst_Day;
		// Get the number of days for this month
		nDays = cts.GetDays();
		if(nDays == 29)
			m_ListDay.AddString("29");
	}
	if(cursel >= (nDays - 1))
	{
		m_ListDay.SetCurSel(nDays - 1);
		itoa(nDays, string, 10);
		theApp.EventDate[2] = m_SaveState[2] = CString(" ") + string;
	}
}

void CChooseSpecificDate::Set_List_Entry()
{
	// Do the standard EventDate assembly.
	theApp.EventDate[0] = m_SaveState[0] = m_SaveState[1].Left(3) + m_SaveState[2];
	// The following two lines were added in version 1.1 to fix a bug where the state of the Annual
	// check box was forgotten after changing the date.  Found by John Myers.
	if(!m_Annual.GetCheck()) // Add the year string.
		theApp.EventDate[0] += m_SaveState[3];
}

void CChooseSpecificDate::OnOK()
{
	// Do nothing, so that the window doesn't disappear when the user presses Enter.
}

void CChooseSpecificDate::OnCancel()
{
	// Do nothing, so that the window doesn't disappear when the user presses Esc.
}
