// DaysEase.h : main header file for the DAYSEASE application
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
/*
	Bug fixes for version 1.1

	CChooseSpecificDate::Set_List_Entry()
	The state of the Annual check box was forgotten after changing the date.
	Found by John Myers.

	CDaysEaseView::Calculate_Easter()
	The Easter dates falling before the tenth of the month were not recognized.
	Found by Larry Howson.

	CDaysEaseView::Draw_Calendar()
	Some printers would not center the page if the left margin was greater than the right margin.
	Found by Terry Farr.

	CDaysEaseView::OnMouseMove() 
	Line was changed so that the code would compile without a warning in VC++ 6.0.
	Found by Gary Johnson.

	CDaysEaseView::Mini_Month()
	Exclude years prior to 1970 and after 2037.
	Found by Dennis Cummins.

	CEventsDlg::Adjust_Horz_Scroll()
	Added this function to enable horizontal scroll for the Events list.

	CMainFrame::OnClose()
	CDaysEaseApp::InitInstance()
	Made changes to save and restore the maximized state of the window.
*/

#if !defined(AFX_DAYSEASE_H__C4677987_E676_11D1_A893_444553540000__INCLUDED_)
#define AFX_DAYSEASE_H__C4677987_E676_11D1_A893_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CDaysEaseApp:
// See DaysEase.cpp for the implementation of this class
//
#define MY_BUF_SIZE 80
#define MAX_NOTE	120
#define MY_TAB_STOP	45
class CMainFrame;
class CDaysEaseDoc;
class CDaysEaseView;

class CDaysEaseApp : public CWinApp
{
public:
	void Set_Modified_Flag();
	void Update_View();
	void Empty_Event_Array();
	void Set_Main_Pointer(CMainFrame* pThis) {pMain = pThis;}
	void Set_Doc_Pointer(CDaysEaseDoc* pThis) {pDoc = pThis;}
	void Set_View_Pointer(CDaysEaseView* pThis) {pView = pThis;}
	CMainFrame* Main_Pointer() {return pMain;}
	CDaysEaseDoc* Doc_Pointer() {return pDoc;}
	CDaysEaseView* View_Pointer() {return pView;}
	BYTE TitleItalic;
	BYTE NotesItalic;
	BYTE WkdayItalic;
	BYTE DateItalic;
	LONG WkdayWeight;
	LONG DateWeight;
	LONG NotesWeight;
	LONG TitleWeight;
	CRect page_rect;
	double gAspect;
	int nDt_Swap;
	BOOL fSizing;
	COLORREF DateColor;
	COLORREF TitleColor;
	COLORREF NotesColor;
	COLORREF WkdayColor;
	CString EventDate[4];
	CString m_Eventgrid[7][6];
	CString csEventList;
	CString csTitleFont;
	CString csNotesFont;
	CString csDateFont;
	CString csWkdayFont;
	short PrintColor;
	short PaperSize;
	short Orientation;
	CString PrinterName;
	UINT nDateSwap;
	UINT nNoteLarge;
	UINT nDateLarge;
	int nDt_Custom;
	CString m_csCurrentDir;
	CString m_csCmdLineIni;
	CDaysEaseApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDaysEaseApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL OnIdle(LONG lCount);
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CDaysEaseApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
protected:
	BOOL Verify_Event_File(CString filename);
	CDaysEaseDoc* pDoc;
	CMainFrame* pMain;
	CDaysEaseView* pView;
	BOOL Read_Profile_Data();
	BOOL Uninstall();
	void Add_Reg_Keys();
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DAYSEASE_H__C4677987_E676_11D1_A893_444553540000__INCLUDED_)
