// DaysEaseView.h : interface of the CDaysEaseView class
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DAYSEASEVIEW_H__C467798F_E676_11D1_A893_444553540000__INCLUDED_)
#define AFX_DAYSEASEVIEW_H__C467798F_E676_11D1_A893_444553540000__INCLUDED_

#include "CalTracker.h"	// Added by ClassView
#include "GraphTracker.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDaysEaseDoc;

class CDaysEaseView : public CView
{
protected: // create from serialization only
	CDaysEaseView();
	DECLARE_DYNCREATE(CDaysEaseView)

// Attributes
public:
	//CDaysEaseDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDaysEaseView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void OnInitialUpdate();
	int nCurY;
	int nCurX;
	int nDay;
	double dCW;
	double dCH;
	BOOL fEdit;
	BOOL fNote;
	BOOL fEvents;
	BOOL fCalPos;
	BOOL fGrafPos;
	BOOL fGontop;
	CRect m_rect[7][6];
	CRect crTitle;
	CCalTracker m_calendar;
	CGraphTracker m_graphic;
	CPrintDialog* m_pPrintDialog;
	void Get_Printer_Stats(HDC hDC);
	virtual ~CDaysEaseView();

protected:
	int row;
	int col;
	int physoffsety;
	int physoffsetx;
	int cyPage;
	int cxPage;
	int physheight;
	int physwidth;
	BOOL fNote_Warn;
	BOOL fNewDoc;
	CString csEaster;
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	void Create_Print_Dlg();
	void Set_Status_Text(int pane, CString text);
	void Save_Note();
	BOOL Img_Hit_Test(CPoint point);
	BOOL Cal_Hit_Test(CPoint point);
	BOOL Valid_Box(int x, int y);
	void Position_Graphic(CPoint point);
	void Position_Calendar(CPoint point);
	BOOL Validate_Printer();
	BOOL Save_Printer_Changes(BOOL new_setting);
	void OnFilePrint();
	void Draw_Calendar(CDC* pDC);
	CString Find_Event(CString look, CString csDocData);
	CString Insert_Events(CString D, CString csDocData, int week, BOOL last);
	void Draw_Title_Date(CDC * pDC, CRect rect, BOOL trufal);
	void Mini_Month(CDC * pDC, CRect rect, int month, int year, int X);
	void Insert_Day_Number(CDC * pDC, CRect * pRect, int k, int nDays);
	void Print_Month(CDC * pDC, int print_left, int print_top,
		int print_right, int print_bottom);
	void Print_Year(CDC * pDC, int print_left, int print_top,
		int print_right, int print_bottom);
	void View_Month(CDC * pDC);
	void Draw_Graphic(CDC * pDC);
	void View_Year(CDC * pDC);
	void Calculate_Easter();
	void Set_Title();
	//{{AFX_MSG(CDaysEaseView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetup();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnFileNew();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/*
#ifndef _DEBUG  // debug version in DaysEaseView.cpp
inline CDaysEaseDoc* CDaysEaseView::GetDocument()
   { return (CDaysEaseDoc*)m_pDocument; }
#endif
*/
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DAYSEASEVIEW_H__C467798F_E676_11D1_A893_444553540000__INCLUDED_)
