// ImageDlg.cpp : implementation file
//
/*
	DaysEase - PC Magazine file download utility
	Copyright  1998-1999 Ziff-Davis, Inc.  All rights reserved.
	First published in PC Magazine, US Edition
	December 1, 1998.
	Written by Richard A. Ellingson
*/
#include "stdafx.h"
#include "DaysEase.h"
#include "ImageDlg.h"
#include "MainFrm.h"
#include "DaysEaseDoc.h"
#include "DaysEaseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CDaysEaseApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CImageDlg dialog


CImageDlg::CImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CImageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CImageDlg)
	//}}AFX_DATA_INIT
}


void CImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImageDlg)
	DDX_Control(pDX, IDC_TRANSPARENT, m_Transparent);
	DDX_Control(pDX, IDC_GRAPHIC, m_Graphic);
	DDX_Control(pDX, IDC_DELETEIMAGE, m_DeleteImage);
	DDX_Control(pDX, IDC_GVERTH, m_Gverth);
	DDX_Control(pDX, IDC_GVERTF, m_Gvertf);
	DDX_Control(pDX, IDC_GHORIZH, m_Ghorizh);
	DDX_Control(pDX, IDC_GHORIZF, m_Ghorizf);
	DDX_Control(pDX, IDC_IMAGETITLE, m_ImageTitle);
	DDX_Control(pDX, IDC_GCENTERV, m_GcenterV);
	DDX_Control(pDX, IDC_GCENTERH, m_GcenterH);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CImageDlg, CDialog)
	//{{AFX_MSG_MAP(CImageDlg)
	ON_BN_CLICKED(IDC_GCENTERH, OnGcenterh)
	ON_BN_CLICKED(IDC_GCENTERV, OnGcenterv)
	ON_BN_CLICKED(IDC_GHORIZF, OnGhorizf)
	ON_BN_CLICKED(IDC_GHORIZH, OnGhorizh)
	ON_BN_CLICKED(IDC_GRAPHIC, OnGraphic)
	ON_BN_CLICKED(IDC_GVERTF, OnGvertf)
	ON_BN_CLICKED(IDC_GVERTH, OnGverth)
	ON_BN_CLICKED(IDC_DELETEIMAGE, OnDeleteimage)
	ON_BN_CLICKED(IDC_TRANSPARENT, OnTransparent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageDlg message handlers

// Handler for Horizontal Center button
void CImageDlg::OnGcenterh() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	int ntop = pView->m_calendar.m_rect.top - theApp.page_rect.top;
	int nbottom = theApp.page_rect.bottom - pView->m_calendar.m_rect.bottom;
	int width = pView->m_graphic.m_rect.Width();

	pView->m_graphic.m_rect.left = pView->m_calendar.m_rect.CenterPoint().x - width/2;
	pView->m_graphic.m_rect.right = pView->m_graphic.m_rect.left + width;
	pDoc->gratio_top = pView->m_graphic.m_rect.top/pView->dCH;
	pDoc->gratio_bottom = pView->m_graphic.m_rect.bottom/pView->dCH;
	pDoc->gratio_left = pView->m_graphic.m_rect.left/pView->dCW;
	pDoc->gratio_right = pView->m_graphic.m_rect.right/pView->dCW;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Handler for Vertical  Center button
void CImageDlg::OnGcenterv() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	int ntop = pView->m_calendar.m_rect.top - theApp.page_rect.top;
	int nbottom = theApp.page_rect.bottom - pView->m_calendar.m_rect.bottom;
	int height = pView->m_graphic.m_rect.Height();

	if(ntop > height)
	{
		pView->m_graphic.m_rect.top = theApp.page_rect.top + ntop/2 - height/2;
		pView->m_graphic.m_rect.bottom = pView->m_graphic.m_rect.top + height;
	}
	else
		if(nbottom > height)
		{
			pView->m_graphic.m_rect.bottom = theApp.page_rect.bottom - nbottom/2  + height/2;;
			pView->m_graphic.m_rect.top = pView->m_graphic.m_rect.bottom - height;
		}
	pDoc->gratio_top = pView->m_graphic.m_rect.top/pView->dCH;
	pDoc->gratio_bottom = pView->m_graphic.m_rect.bottom/pView->dCH;
	pDoc->gratio_left = pView->m_graphic.m_rect.left/pView->dCW;
	pDoc->gratio_right = pView->m_graphic.m_rect.right/pView->dCW;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Handler for Horizontal Full Width button
void CImageDlg::OnGhorizf() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	if(!pDoc->fGraphic)
		return;
	pDoc->gratio_left = theApp.page_rect.left/pView->dCW;
	pDoc->gratio_right = theApp.page_rect.right/pView->dCW;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Handler for Horizontal Fill button
void CImageDlg::OnGhorizh() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	if(!pDoc->fGraphic)
		return;
	pView->m_graphic.m_rect.left = pView->m_calendar.m_rect.left;
	pView->m_graphic.m_rect.right = pView->m_calendar.m_rect.right;
	pDoc->gratio_left = pView->m_graphic.m_rect.left/pView->dCW;
	pDoc->gratio_right = pView->m_graphic.m_rect.right/pView->dCW;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Handler for New Image button
void CImageDlg::OnGraphic() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	CFileDialog dlg(TRUE, "bmp", "*.bmp", NULL, "Bitmap files (*.bmp)|*.bmp||");
    if(dlg.DoModal() != IDOK)
		return;
    pDoc->fGraphic = pDoc->m_dib.AttachMapFile(dlg.GetPathName(), TRUE);
	if(pDoc->fGraphic)
	{
		pView->fGrafPos++;
		pDoc->csImageName = dlg.GetFileName();
		CSize size = pDoc->m_dib.GetDimensions();
		theApp.gAspect = (double)size.cx/(double)size.cy;
		pView->m_graphic.m_rect.left = theApp.page_rect.left;
		pView->m_graphic.m_rect.right = theApp.page_rect.left + (theApp.page_rect.right/4);
		pView->m_graphic.m_rect.top = theApp.page_rect.top;
		pView->m_graphic.m_rect.bottom = theApp.page_rect.top + 
			(int)((double)pView->m_graphic.m_rect.Width()/theApp.gAspect);
		pDoc->gratio_right = pView->m_graphic.m_rect.right/pView->dCW;
		pDoc->gratio_left = pView->m_graphic.m_rect.left/pView->dCW;
		pDoc->gratio_top = pView->m_graphic.m_rect.top/pView->dCH;
		pDoc->gratio_bottom = pView->m_graphic.m_rect.bottom/pView->dCH;
		Enable_Controls(TRUE);
		theApp.Main_Pointer()->m_wndStatusBar.SetPaneText(0, "Position graphic");
		SetFocus();
		theApp.Set_Modified_Flag();
		theApp.Update_View();
    }
}
// Handler for Vertical Full Height button
void CImageDlg::OnGvertf() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	if(!pDoc->fGraphic)
		return;
	pDoc->gratio_top = theApp.page_rect.top/pView->dCH;
	pDoc->gratio_bottom = theApp.page_rect.bottom/pView->dCH;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Handler for Vertical Fill button
void CImageDlg::OnGverth() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	if(!pDoc->fGraphic)
		return;
	int ntop = pView->m_calendar.m_rect.top - theApp.page_rect.top;
	int nbottom = theApp.page_rect.bottom - pView->m_calendar.m_rect.bottom;
	if((ntop >= pView->m_graphic.m_sizeMin.cx) && (ntop >= nbottom))
	{
		pView->m_graphic.m_rect.top = theApp.page_rect.top;
		pView->m_graphic.m_rect.bottom = pView->m_calendar.m_rect.top;
	}
	if((nbottom >= pView->m_graphic.m_sizeMin.cx) && (nbottom > ntop))
	{
		pView->m_graphic.m_rect.top = pView->m_calendar.m_rect.bottom;
		pView->m_graphic.m_rect.bottom = theApp.page_rect.bottom;
	}
	pDoc->gratio_top = pView->m_graphic.m_rect.top/pView->dCH;
	pDoc->gratio_bottom = pView->m_graphic.m_rect.bottom/pView->dCH;
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
// Dummy handler
void CImageDlg::OnCancel()
{
	// Do nothing, so that the window doesn't disappear when the user presses Esc.
}

void CImageDlg::Enable_Controls(BOOL trufal)
{
	m_Ghorizf.EnableWindow(trufal);
	m_Ghorizh.EnableWindow(trufal);
	m_Gvertf.EnableWindow(trufal);
	m_Gverth.EnableWindow(trufal);
	m_GcenterH.EnableWindow(trufal);
	m_GcenterV.EnableWindow(trufal);
	m_DeleteImage.EnableWindow(theApp.Doc_Pointer()->fGraphic);
	m_ImageTitle.SetWindowText(theApp.Doc_Pointer()->csImageName);
	m_Transparent.EnableWindow(trufal);
}
// Handler for Delete button
void CImageDlg::OnDeleteimage() 
{
	Delete_Image();
}
// Dummy handler
void CImageDlg::OnOK()
{
	// Do nothing, so that the window doesn't disappear when the user presses Enter.
}

void CImageDlg::Delete_Image()
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();
	CDaysEaseView* pView = theApp.View_Pointer();

	// If we have an image loaded, delete it.
	if(pDoc->fGraphic)
	{
		pDoc->m_dib.Empty();
		pDoc->fGraphic = 0;
		pView->fGrafPos = 0;
		theApp.Main_Pointer()->m_wndStatusBar.SetPaneText(0, "");
		pDoc->csImageName = "no image loaded";
		Enable_Controls(pDoc->fGraphic);
		theApp.Set_Modified_Flag();
		theApp.Update_View();
	}
}
// Handler for Trasnparent calendar checkbox
void CImageDlg::OnTransparent() 
{
	CDaysEaseDoc* pDoc = theApp.Doc_Pointer();

	// Get the current check box state and set the document flag equal.
	if(m_Transparent.GetCheck())
		pDoc->fTransparent++;
	else
		pDoc->fTransparent = 0;
	// Set the document Modified flag and update the view.
	theApp.Set_Modified_Flag();
	theApp.Update_View();
}
